package infoh509.cours6;

import java.io.*;
import org.jdom.*;
import org.jdom.filter.*;
import org.jdom.input.*;
import org.jdom.output.*;

public class DoubleSugar {

	public static void main(String[] args) {

		try {
			SAXBuilder b = new SAXBuilder();
			Document d = b.build(new File("data/recipes.xml"));
			
			doubleTheSugar(d);

			XMLOutputter outputter = new XMLOutputter();
			outputter.output(d,System.out);

		} catch (JDOMParseException e) { 
			System.err.println(e.toString()); 
		} catch (Exception e) { 
			e.printStackTrace(); 
		}
	}

	@SuppressWarnings("unchecked")
	public static void doubleTheSugar( Document d) throws DataConversionException {

		Filter f = new ElementFilter("ingredient");
		java.util.Iterator i = d.getDescendants(f);
		
		while ( i.hasNext() ) {
		    Element e = (Element)i.next();
		    if (e.getAttributeValue("name").equals("sugar")) {
		      double amount = e.getAttribute("amount").getDoubleValue();
		      e.setAttribute("amount",new Double(2*amount).toString());
		    }
		  }
	}
}
