package infoh509.cours6;

import java.io.*;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.xpath.XPath;


public class DoubleSugarWithXPath {
	public static void main(String[] args) {

		try {
			SAXBuilder b = new SAXBuilder();
			Document d = b.build(new File("data/recipes.xml"));
			
			doubleTheSugar(d);

			XMLOutputter outputter = new XMLOutputter();
			outputter.output(d,System.out);

		} catch (JDOMParseException e) { 
			System.err.println(e.toString()); 
		} catch (Exception e) { 
			e.printStackTrace(); 
		}
	}

	@SuppressWarnings("unchecked")
	public static void doubleTheSugar( Document d) throws JDOMException {
		XPath p = XPath.newInstance("//ingredient[@name='sugar']");		  
		java.util.Iterator i = p.selectNodes(d).iterator();
		while ( i.hasNext() ) {
			Element e = (Element)i.next();
			double amount = e.getAttribute("amount").getDoubleValue();
			e.setAttribute( "amount",new Double(2*amount).toString() );
		}
	}
}
