package infoh509.cours6;

import java.io.*;

import org.jdom.*;

import org.jdom.input.*;
import org.jdom.output.*;


public class ElaborateButter {

	public static void main(String[] args) {

		try {
			SAXBuilder b = new SAXBuilder();
			Document d = b.build(new File("data/recipes.xml"));
			
			elaborate(d.getRootElement());

			XMLOutputter outputter = new XMLOutputter();
			outputter.output(d,System.out);

		} catch (JDOMParseException e) { 
			System.err.println(e.toString()); 
		} catch (Exception e) { 
			e.printStackTrace(); 
		}
	}

	@SuppressWarnings("unchecked")
	public static void elaborate( Element e) throws DataConversionException {

		Namespace rcp =
			Namespace.getNamespace("http://www.brics.dk/ixwt/recipes");

		java.util.ListIterator i = e.getChildren().listIterator();
		while ( i.hasNext() ) {
			Element c = (Element)i.next();

			if (c.getName().equals("ingredient") &&
					c.getAttributeValue("name").equals("butter")) {
			
				//Create new elements in the namespace
				Element butter = new Element("ingredient", rcp);
				butter.setAttribute("name","butter");

				Element cream = new Element("ingredient",rcp);
				cream.setAttribute("name","cream");
				cream.setAttribute("unit",c.getAttributeValue("unit"));
				
				double amount = c.getAttribute("amount").getDoubleValue();
				cream.setAttribute("amount",new Double(2*amount).toString());
				butter.addContent(cream);
				Element churn = new Element("preparation",rcp);
				churn.addContent("Churn until the cream turns to butter.");
				butter.addContent(churn);
				
				//Replace the current node with the new one
				i.set((Element)butter);			
			} else {
				elaborate(c);
			}
		}
	}
}
